/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */



#ifndef SBK_QTWEBCHANNEL_PYTHON_H
#define SBK_QTWEBCHANNEL_PYTHON_H

#include <sbkpython.h>
#include <conversions.h>
#include <sbkenum.h>
#include <basewrapper.h>
#include <bindingmanager.h>
#include <memory>

#include <pysidesignal.h>
// Module Includes
#include <pyside2_qtcore_python.h>

// Binded library includes
#include <qwebchannel.h>
#include <qwebchannelabstracttransport.h>
// Conversion Includes - Primitive Types
#include <QString>
#include <typeresolver.h>
#include <QStringList>
#include <wtypes.h>
#include <signalmanager.h>
#include <qabstractitemmodel.h>

// Conversion Includes - Container Types
#include <QMultiMap>
#include <QSet>
#include <QLinkedList>
#include <QQueue>
#include <QStack>
#include <QVector>
#include <pysideconversions.h>
#include <QList>
#include <QMap>
#include <QPair>

// Type indices
#define SBK_QWEBCHANNELABSTRACTTRANSPORT_IDX                         1
#define SBK_QWEBCHANNEL_IDX                                          0
#define SBK_QtWebChannel_IDX_COUNT                                   2

// This variable stores all Python types exported by this module.
extern PyTypeObject** SbkPySide2_QtWebChannelTypes;

// This variable stores all type converters exported by this module.
extern SbkConverter** SbkPySide2_QtWebChannelTypeConverters;

// Converter indices
#define SBK_QTWEBCHANNEL_QLIST_QOBJECTPTR_IDX                        0 // const QList<QObject * > &
#define SBK_QTWEBCHANNEL_QLIST_QBYTEARRAY_IDX                        1 // QList<QByteArray >
#define SBK_QTWEBCHANNEL_QHASH_QSTRING_QOBJECTPTR_IDX                2 // const QHash<QString, QObject * > &
#define SBK_QTWEBCHANNEL_QLIST_QVARIANT_IDX                          3 // QList<QVariant >
#define SBK_QTWEBCHANNEL_QLIST_QSTRING_IDX                           4 // QList<QString >
#define SBK_QTWEBCHANNEL_QMAP_QSTRING_QVARIANT_IDX                   5 // QMap<QString, QVariant >
#define SBK_QtWebChannel_CONVERTERS_IDX_COUNT                        6

// Macros for type check

namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
template<> inline PyTypeObject* SbkType< ::QWebChannelAbstractTransport >() { return reinterpret_cast<PyTypeObject*>(SbkPySide2_QtWebChannelTypes[SBK_QWEBCHANNELABSTRACTTRANSPORT_IDX]); }
template<> inline PyTypeObject* SbkType< ::QWebChannel >() { return reinterpret_cast<PyTypeObject*>(SbkPySide2_QtWebChannelTypes[SBK_QWEBCHANNEL_IDX]); }

} // namespace Shiboken

#endif // SBK_QTWEBCHANNEL_PYTHON_H

